# Changelog

## [2.0.0](https://github.com/firefly-cpp/NiaAML/tree/2.0.0) (2024-04-23)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.2.0...2.0.0)

**Implemented enhancements:**

- implement last steps in the recommended community standards [\#86](https://github.com/firefly-cpp/NiaAML/issues/86)
- Support for regression tasks and feature selection [\#69](https://github.com/firefly-cpp/NiaAML/issues/69)
- 69 support for regression tasks and feature selection [\#93](https://github.com/firefly-cpp/NiaAML/pull/93) ([LaurenzBeck](https://github.com/LaurenzBeck))

**Closed issues:**

- Add "inrepositories" badge [\#88](https://github.com/firefly-cpp/NiaAML/issues/88)
- First Contribution: minor styling changes in `README.md`  [\#83](https://github.com/firefly-cpp/NiaAML/issues/83)
- Warnings [\#80](https://github.com/firefly-cpp/NiaAML/issues/80)
- Visualization of results [\#18](https://github.com/firefly-cpp/NiaAML/issues/18)

**Merged pull requests:**

- Adhere to Community standards [\#91](https://github.com/firefly-cpp/NiaAML/pull/91) ([LaurenzBeck](https://github.com/LaurenzBeck))
- 📝 re-styled README [\#87](https://github.com/firefly-cpp/NiaAML/pull/87) ([LaurenzBeck](https://github.com/LaurenzBeck))
- Dependency version [\#82](https://github.com/firefly-cpp/NiaAML/pull/82) ([lahovniktadej](https://github.com/lahovniktadej))

## [1.2.0](https://github.com/firefly-cpp/NiaAML/tree/1.2.0) (2024-02-16)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.12...1.2.0)

**Merged pull requests:**

- Warnings [\#81](https://github.com/firefly-cpp/NiaAML/pull/81) ([lahovniktadej](https://github.com/lahovniktadej))
- Increment minimum pandas version [\#79](https://github.com/firefly-cpp/NiaAML/pull/79) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.12](https://github.com/firefly-cpp/NiaAML/tree/1.1.12) (2023-04-30)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.11...1.1.12)

## [1.1.11](https://github.com/firefly-cpp/NiaAML/tree/1.1.11) (2022-09-16)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.10...1.1.11)

**Merged pull requests:**

- Bump version to 1.1.11 [\#78](https://github.com/firefly-cpp/NiaAML/pull/78) ([firefly-cpp](https://github.com/firefly-cpp))
- Use poetry-core [\#77](https://github.com/firefly-cpp/NiaAML/pull/77) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.10](https://github.com/firefly-cpp/NiaAML/tree/1.1.10) (2022-08-17)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.9...1.1.10)

**Closed issues:**

- Publish to PyPI [\#73](https://github.com/firefly-cpp/NiaAML/issues/73)

**Merged pull requests:**

- Update dependencies [\#76](https://github.com/firefly-cpp/NiaAML/pull/76) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.9](https://github.com/firefly-cpp/NiaAML/tree/1.1.9) (2022-05-25)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.8...1.1.9)

**Closed issues:**

- Test with python-scikit-learn 1.1.0 is not passing [\#71](https://github.com/firefly-cpp/NiaAML/issues/71)

**Merged pull requests:**

- Bump version [\#75](https://github.com/firefly-cpp/NiaAML/pull/75) ([firefly-cpp](https://github.com/firefly-cpp))
- Do not package the tests [\#74](https://github.com/firefly-cpp/NiaAML/pull/74) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.8](https://github.com/firefly-cpp/NiaAML/tree/1.1.8) (2022-05-24)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.7...1.1.8)

**Merged pull requests:**

- Removed deprecated sklearn warnings [\#72](https://github.com/firefly-cpp/NiaAML/pull/72) ([zStupan](https://github.com/zStupan))
- Update README.md [\#70](https://github.com/firefly-cpp/NiaAML/pull/70) ([firefly-cpp](https://github.com/firefly-cpp))
- Run tests with github action [\#68](https://github.com/firefly-cpp/NiaAML/pull/68) ([lukapecnik](https://github.com/lukapecnik))
- docs: add lukapecnik as a contributor for infra [\#67](https://github.com/firefly-cpp/NiaAML/pull/67) ([allcontributors[bot]](https://github.com/apps/allcontributors))
- docs: add musicinmybrain as a contributor for code, infra [\#66](https://github.com/firefly-cpp/NiaAML/pull/66) ([allcontributors[bot]](https://github.com/apps/allcontributors))
- docs: add zStupan as a contributor for code [\#65](https://github.com/firefly-cpp/NiaAML/pull/65) ([allcontributors[bot]](https://github.com/apps/allcontributors))

## [1.1.7](https://github.com/firefly-cpp/NiaAML/tree/1.1.7) (2022-02-21)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.6...1.1.7)

**Closed issues:**

- Update to the latest niapy stable release [\#62](https://github.com/firefly-cpp/NiaAML/issues/62)
- Example file pipeline.ppln is out of date [\#60](https://github.com/firefly-cpp/NiaAML/issues/60)
- np.int is a deprecated alias [\#56](https://github.com/firefly-cpp/NiaAML/issues/56)
- Remove setup.py file [\#54](https://github.com/firefly-cpp/NiaAML/issues/54)

**Merged pull requests:**

- Update niapy [\#64](https://github.com/firefly-cpp/NiaAML/pull/64) ([lukapecnik](https://github.com/lukapecnik))
- Update README.md [\#63](https://github.com/firefly-cpp/NiaAML/pull/63) ([firefly-cpp](https://github.com/firefly-cpp))
- Eschew deprecated numpy aliases for builtins [\#61](https://github.com/firefly-cpp/NiaAML/pull/61) ([musicinmybrain](https://github.com/musicinmybrain))
- Corrected dependencies in CONTRIBUTING [\#59](https://github.com/firefly-cpp/NiaAML/pull/59) ([firefly-cpp](https://github.com/firefly-cpp))
- Do not install text files in site-packages/ [\#58](https://github.com/firefly-cpp/NiaAML/pull/58) ([musicinmybrain](https://github.com/musicinmybrain))
- Use the latest upstream's release for niapy [\#57](https://github.com/firefly-cpp/NiaAML/pull/57) ([firefly-cpp](https://github.com/firefly-cpp))
- Add reference links [\#55](https://github.com/firefly-cpp/NiaAML/pull/55) ([firefly-cpp](https://github.com/firefly-cpp))
- Add link to the API [\#53](https://github.com/firefly-cpp/NiaAML/pull/53) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.6](https://github.com/firefly-cpp/NiaAML/tree/1.1.6) (2021-06-27)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.5...1.1.6)

**Closed issues:**

- Upgrade to the latest niapy release [\#51](https://github.com/firefly-cpp/NiaAML/issues/51)

**Merged pull requests:**

- Update to the latest niapy version and fix docs build warnings [\#52](https://github.com/firefly-cpp/NiaAML/pull/52) ([zStupan](https://github.com/zStupan))

## [1.1.5](https://github.com/firefly-cpp/NiaAML/tree/1.1.5) (2021-06-01)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.4...1.1.5)

**Merged pull requests:**

- Citation details [\#50](https://github.com/firefly-cpp/NiaAML/pull/50) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.4](https://github.com/firefly-cpp/NiaAML/tree/1.1.4) (2021-05-24)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.3...1.1.4)

**Closed issues:**

- Unable to install with conda [\#47](https://github.com/firefly-cpp/NiaAML/issues/47)

## [1.1.3](https://github.com/firefly-cpp/NiaAML/tree/1.1.3) (2021-05-23)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.2...1.1.3)

## [1.1.2](https://github.com/firefly-cpp/NiaAML/tree/1.1.2) (2021-05-19)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.1...1.1.2)

**Merged pull requests:**

- Update niapy dependency [\#49](https://github.com/firefly-cpp/NiaAML/pull/49) ([lukapecnik](https://github.com/lukapecnik))

## [1.1.1](https://github.com/firefly-cpp/NiaAML/tree/1.1.1) (2021-03-09)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.1rc2...1.1.1)

**Merged pull requests:**

- logo \[ci skip\] [\#48](https://github.com/firefly-cpp/NiaAML/pull/48) ([lukapecnik](https://github.com/lukapecnik))
- Fedora package pushed to stable [\#46](https://github.com/firefly-cpp/NiaAML/pull/46) ([firefly-cpp](https://github.com/firefly-cpp))
- Restructuring of paper and editorial changes [\#45](https://github.com/firefly-cpp/NiaAML/pull/45) ([adi3](https://github.com/adi3))
- Corrections of paper [\#44](https://github.com/firefly-cpp/NiaAML/pull/44) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.1.1rc2](https://github.com/firefly-cpp/NiaAML/tree/1.1.1rc2) (2020-12-22)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.1rc1...1.1.1rc2)

## [1.1.1rc1](https://github.com/firefly-cpp/NiaAML/tree/1.1.1rc1) (2020-12-22)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.1.0...1.1.1rc1)

**Merged pull requests:**

- Original NiaAML method support \[ci skip\] [\#43](https://github.com/firefly-cpp/NiaAML/pull/43) ([lukapecnik](https://github.com/lukapecnik))

## [1.1.0](https://github.com/firefly-cpp/NiaAML/tree/1.1.0) (2020-12-16)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc7...1.1.0)

## [1.0.0rc7](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc7) (2020-12-14)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc6...1.0.0rc7)

**Closed issues:**

- References [\#40](https://github.com/firefly-cpp/NiaAML/issues/40)

**Merged pull requests:**

- Paper update [\#42](https://github.com/firefly-cpp/NiaAML/pull/42) ([firefly-cpp](https://github.com/firefly-cpp))
- minor corrections in examples [\#39](https://github.com/firefly-cpp/NiaAML/pull/39) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.0.0rc6](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc6) (2020-12-12)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc5...1.0.0rc6)

**Closed issues:**

- Conda package [\#34](https://github.com/firefly-cpp/NiaAML/issues/34)

**Merged pull requests:**

- Additional features [\#38](https://github.com/firefly-cpp/NiaAML/pull/38) ([lukapecnik](https://github.com/lukapecnik))
- Conda fix \[ci skip\] [\#37](https://github.com/firefly-cpp/NiaAML/pull/37) ([lukapecnik](https://github.com/lukapecnik))
- Orcid identifiers added [\#36](https://github.com/firefly-cpp/NiaAML/pull/36) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.0.0rc5](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc5) (2020-12-11)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc4...1.0.0rc5)

**Closed issues:**

- Installation problems [\#31](https://github.com/firefly-cpp/NiaAML/issues/31)

**Merged pull requests:**

- Conda support [\#35](https://github.com/firefly-cpp/NiaAML/pull/35) ([lukapecnik](https://github.com/lukapecnik))

## [1.0.0rc4](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc4) (2020-12-10)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc3...1.0.0rc4)

**Merged pull requests:**

- Python 3.6 support [\#33](https://github.com/firefly-cpp/NiaAML/pull/33) ([lukapecnik](https://github.com/lukapecnik))
- First version of paper [\#32](https://github.com/firefly-cpp/NiaAML/pull/32) ([firefly-cpp](https://github.com/firefly-cpp))

## [1.0.0rc3](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc3) (2020-12-10)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc2...1.0.0rc3)

## [1.0.0rc2](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc2) (2020-12-08)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/1.0.0rc1...1.0.0rc2)

**Merged pull requests:**

- feature missing values imputation [\#30](https://github.com/firefly-cpp/NiaAML/pull/30) ([lukapecnik](https://github.com/lukapecnik))
- README updated [\#29](https://github.com/firefly-cpp/NiaAML/pull/29) ([firefly-cpp](https://github.com/firefly-cpp))
- Readme update, encoder check for type int64 [\#28](https://github.com/firefly-cpp/NiaAML/pull/28) ([lukapecnik](https://github.com/lukapecnik))
- Markdown and docs [\#27](https://github.com/firefly-cpp/NiaAML/pull/27) ([lukapecnik](https://github.com/lukapecnik))

## [1.0.0rc1](https://github.com/firefly-cpp/NiaAML/tree/1.0.0rc1) (2020-12-06)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.4...1.0.0rc1)

**Merged pull requests:**

- Added support for categorical features [\#26](https://github.com/firefly-cpp/NiaAML/pull/26) ([lukapecnik](https://github.com/lukapecnik))

## [0.1.4](https://github.com/firefly-cpp/NiaAML/tree/0.1.4) (2020-12-05)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.3...0.1.4)

**Merged pull requests:**

- remove 10-fold cross validation from benchmark, critical bug fix [\#25](https://github.com/firefly-cpp/NiaAML/pull/25) ([lukapecnik](https://github.com/lukapecnik))
- run all experiments at once [\#24](https://github.com/firefly-cpp/NiaAML/pull/24) ([firefly-cpp](https://github.com/firefly-cpp))

## [0.1.3](https://github.com/firefly-cpp/NiaAML/tree/0.1.3) (2020-12-04)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.3a1...0.1.3)

## [0.1.3a1](https://github.com/firefly-cpp/NiaAML/tree/0.1.3a1) (2020-12-01)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.2...0.1.3a1)

**Merged pull requests:**

- 0.1.3a1 pre-release python 3.7 compatibility [\#23](https://github.com/firefly-cpp/NiaAML/pull/23) ([lukapecnik](https://github.com/lukapecnik))
- Fixes and additions [\#22](https://github.com/firefly-cpp/NiaAML/pull/22) ([lukapecnik](https://github.com/lukapecnik))

## [0.1.2](https://github.com/firefly-cpp/NiaAML/tree/0.1.2) (2020-11-30)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.2a1...0.1.2)

**Implemented enhancements:**

- On the use of unittest [\#2](https://github.com/firefly-cpp/NiaAML/issues/2)

**Closed issues:**

- Description of examples [\#16](https://github.com/firefly-cpp/NiaAML/issues/16)

**Merged pull requests:**

- readme.rst fix, pipeline fix [\#21](https://github.com/firefly-cpp/NiaAML/pull/21) ([lukapecnik](https://github.com/lukapecnik))
- Travis ci integration [\#20](https://github.com/firefly-cpp/NiaAML/pull/20) ([lukapecnik](https://github.com/lukapecnik))
- badges and readme update [\#19](https://github.com/firefly-cpp/NiaAML/pull/19) ([lukapecnik](https://github.com/lukapecnik))

## [0.1.2a1](https://github.com/firefly-cpp/NiaAML/tree/0.1.2a1) (2020-11-29)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.1...0.1.2a1)

**Closed issues:**

- Information about hyperparameter tuning [\#15](https://github.com/firefly-cpp/NiaAML/issues/15)
- CHANGELOG [\#14](https://github.com/firefly-cpp/NiaAML/issues/14)
- Examples [\#13](https://github.com/firefly-cpp/NiaAML/issues/13)

**Merged pull requests:**

- Unittests, examples' description, references added to docs [\#17](https://github.com/firefly-cpp/NiaAML/pull/17) ([lukapecnik](https://github.com/lukapecnik))

## [0.1.1](https://github.com/firefly-cpp/NiaAML/tree/0.1.1) (2020-11-28)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/0.1.0...0.1.1)

**Closed issues:**

- Installation instructions [\#11](https://github.com/firefly-cpp/NiaAML/issues/11)

**Merged pull requests:**

- Contributors table added [\#12](https://github.com/firefly-cpp/NiaAML/pull/12) ([lukapecnik](https://github.com/lukapecnik))

## [0.1.0](https://github.com/firefly-cpp/NiaAML/tree/0.1.0) (2020-11-27)

[Full Changelog](https://github.com/firefly-cpp/NiaAML/compare/fbf47d71adb6ba72aa9210e4ead316b318253862...0.1.0)

**Implemented enhancements:**

- CSV Data Reader class [\#3](https://github.com/firefly-cpp/NiaAML/issues/3)

**Closed issues:**

- A non-functional demo could be written [\#4](https://github.com/firefly-cpp/NiaAML/issues/4)

**Merged pull requests:**

- Framework improvements, docs initialization and readme [\#10](https://github.com/firefly-cpp/NiaAML/pull/10) ([lukapecnik](https://github.com/lukapecnik))
- Pipeline methods implementation [\#9](https://github.com/firefly-cpp/NiaAML/pull/9) ([lukapecnik](https://github.com/lukapecnik))
- Pipeline optimizer progress [\#8](https://github.com/firefly-cpp/NiaAML/pull/8) ([lukapecnik](https://github.com/lukapecnik))
- Implementation of jDEFSTH algorithm for feature selection [\#7](https://github.com/firefly-cpp/NiaAML/pull/7) ([firefly-cpp](https://github.com/firefly-cpp))
- refactoring and variance threshold feature selection implementation [\#6](https://github.com/firefly-cpp/NiaAML/pull/6) ([lukapecnik](https://github.com/lukapecnik))
- NiaPy dependency added [\#5](https://github.com/firefly-cpp/NiaAML/pull/5) ([firefly-cpp](https://github.com/firefly-cpp))



\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*
